# Continuous integration script for Gitlab

before_script:
  - env
  - python3 --version

stages:          # List of stages for jobs, and their order of execution
  - install
  - test
  - deploy

build-job:       # This job runs in the build stage, which runs first.
  stage: install
  script:
    - python3 -m venv .venv
    - source .venv/bin/activate
    - python3 -m pip install -Iv "pip==22.3.1" #TODO: Remove once setup.py can support pip >= 23.1 && CI local pip is updated
    - python3 -m pip install .
    - deactivate
  artifacts:
    paths:
      - .venv/

example-job:   # This job runs in the test stage.
  stage: test    # It only starts when the job in the build stage completes successfully.
  needs: ["build-job"]
  script:
    - source .venv/bin/activate
    - python3 examples/demo.py
    - deactivate
  dependencies:
    - build-job

ampere-env:   # Deploy to AMPERE tools environment only if test is passed.
  stage: deploy
  needs: ["example-job"]
  script:
    - python3 -m venv $HOME/ampere_env
    - source $HOME/ampere_env/bin/activate
    - python3 -m pip install -Iv "pip==22.3.1" #TODO: Remove once setup.py can support pip >= 23.1 && CI local pip is updated
    - python3 -m pip install .
    - deactivate
